package com.jeeplus.test.reimbursementsys.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.jeeplus.test.reimbursementsys.domain.dto.*;

import java.util.List;
import java.util.Map;

/**
 * @author li-peike
 * @version 1.0.0
 * @ClassName ReimbursementSysService.java
 * @Description TODO
 * @createTime 2022年05月06日 10:25:00
 */

public interface WuHanReimbursementBusinessService {
    /**
     * 查询报销人员信息
     * @param id
     * @return
     */
    ReimbursementBusinessDTO queryById(String id);
    /**
     * 查询业务报销额度相关信息
     * @param id
     * @return
     */
    ReimbursementDTO getBusinessById(String id);

    /**
     * 查询武汉业务报销额度相关信息
     * @param id
     * @return
     */
    WuHanReimbursementDTO getWuHanBusinessById(String id);

    /**
     * 查询报销信息(根据人员id和年份)
     * @param reimbursementUser
     * @return
     */
    ReimbursementUserDTO queryByUserIdAndYear(ReimbursementBusinessDTO reimbursementUser);

    /**
     * 查询列表信息
     * @param page
     * @param reimbursementUser
     * @return
     */
    IPage<ReimbursementUserDTO> findList(Page<ReimbursementUserDTO> page, ReimbursementUserDTO reimbursementUser);

    /**
     * 根据人员信息查询报销年份信息
     * @param page
     * @param reimbursementUser
     * @return
     */
    IPage<ReimbursementUserDTO> getYearList(Page<ReimbursementUserDTO> page, ReimbursementUserDTO reimbursementUser);

    /**
     * 保存报销数据信息
     * @param reimbursementUser
     */
    Map<String,Object> save(ReimbursementBusinessDTO reimbursementUser);

    /**
     * 保存武汉报销数据信息
     * @param reimbursementUser
     */
    Map<String,Object> wuHanSave(ReimbursementBusinessDTO reimbursementUser);

    /**
     * 修改报销人员信息
     * @param reimbursementUser
     */
    void update(ReimbursementBusinessDTO reimbursementUser);

    /**
     * 根据id删除人员报销信息（物理删除）
     * @param idList
     */
    void delete(List<String> idList);

    /**
     * 查询列表信息
     * @param reimbursementBusiness
     * @return
     */
    ReimbursementBusinessReturnDTO findListByBusinessCodeId(ReimbursementBusinessDTO reimbursementBusiness);
}
